#!/usr/bin/bltwish -f



############# Plot procedure  #########################


proc plot {{w .frm0}} {

option add *Grid.color			grey50
option add *Grid.dashes			"2 4 2"
option add *Grid.hide			no


    
    global flag1 medcount flagmed fr npti quantum  nomesave
    global scl cutfreq acdc infilgain outfilgain asmin asmax ormin ormax
    global medval flagr aa

  set flagmed 0

 # catch {destroy $w}
 # toplevel $w
 wm title . "Spectrum"


set asmin 0
set asmax [expr $fr/2]
set ormin -8
set ormax -3


frame $w.top 

  if {$quantum == 1} {
    set strlbl "Amplitude  V/sqrt(Hz)"
  } else {
      set strlbl "Amplitude  Flux Quanta /sqrt(Hz)"
  }


option add *Graph.x.title               "Frequency  (Hz)"
option add *Graph.y.title               $strlbl 
option add *Graph.y.rotate              90   

graph $w.top.graph -title "Spectrum" \
	-background beige -width 6i -height 7i -bufferelements 0


frame $w.top.frm1 -background aquamarine3
label $w.top.frm1.lbl1 -bg aquamarine3 -text "Window Amplitude Average :"
label $w.top.frm1.lbl2 -bg aquamarine3 -textvariable medval

frame $w.topr 


label $w.topr.lbl1 -text "  PCI-DAS1602 ADC  "  -foreground blue -background pink
label $w.topr.lbl11 -text "Sample(Hz)      Points(Nr)    V/Phio" -background pink
frame $w.topr.frm11 -background pink

entry $w.topr.frm11.freq -width 7 -relief sunken -textvariable fr -background pink

scale $w.topr.frm11.points   -from 7 -to 14 \
                             -variable b2npt \
                             -resolution 1 \
                             -showvalue no \
                             -bg pink  \
                             -orient horizontal \
                             -length 30 \
                             -command {convert}

label $w.topr.frm11.lblpnt -textvariable npti -background pink -width 2

entry $w.topr.frm11.quantum -width 1 -relief sunken -textvariable quantum -background pink

label $w.topr.lbl12 -text " Scale (V)    " -background pink

frame $w.topr.frm12 -background pink

 radiobutton $w.topr.frm12.rdb1 -text "1.25" -variable scl \
                               -value 8 -bg pink


 radiobutton $w.topr.frm12.rdb2 -text "2.5" -variable scl \
                           -value 4 -bg pink

 radiobutton $w.topr.frm12.rdb3 -text "5" -variable scl \
                           -value 2  -bg pink 

 radiobutton $w.topr.frm12.rdb4 -text "10" -variable scl  \
                           -value 1 -bg pink 




label $w.topr.lbl2 -text " LOW PASS  FILTER " -foreground blue -bg honeydew3
label $w.topr.lbl21 -text "      Coupling           Frequency(Hz)" -bg honeydew3

frame $w.topr.frm21 -bg honeydew3

radiobutton $w.topr.frm21.rdb1 -text "dc" -variable acdc \
                               -value 1 -bg honeydew3 


 radiobutton $w.topr.frm21.rdb2 -text "ac" -variable acdc \
                           -value 0 -bg honeydew3


entry $w.topr.frm21.filfr -width 10 -relief sunken -textvariable cutfreq -bg honeydew3


label $w.topr.lbl22 -text "in          Gain (db)        out " -bg honeydew3

frame $w.topr.frm22  -bg honeydew3 

scale $w.topr.frm22.scl1 -from 0 -to 60 -variable infilgain \
                     -resolution 10  -bg honeydew3 \
                     -orient horizontal

scale $w.topr.frm22.scl2 -from 0 -to 20 -variable outfilgain \
                     -resolution 10  -bg honeydew3 \
                     -orient horizontal

frame $w.topr.frm31 

button $w.topr.frm31.btn3 -text {Log} \
	-command {scalax "minl" 0} \
       -bg yellow -relief groove

button $w.topr.frm31.btn31 -text {Log-Log} \
	-command {scalax "minlg" 0 } \
       -bg yellow  -relief groove

button $w.topr.frm31.btn32 -text {Linear} \
	-command {scalax "minli" 0} \
       -bg yellow -relief groove

frame $w.topr.frm320 -bg honeydew2

label $w.topr.frm320.lbl1 -text " min Freq.            max Freq. "  \
                          -bg honeydew2

frame $w.topr.frm32 -bg  honeydew2

  scale $w.topr.frm32.scl1  -variable asmin -bg yellow \
                     -from 0 \
                     -to $asmax \
                     -bg honeydew2 \
                     -orient horizontal\
		     -command {scalax "min"}

  scale $w.topr.frm32.scl2 -variable asmax -bg yellow \
                     -from 0 \
                     -to $asmax \
                     -bg honeydew2 \
                     -orient horizontal\
		     -command {scalax "max"}

frame $w.topr.frm330 -bg honeydew2

label $w.topr.frm330.lbl1 -text " min Ampli.           max Ampli. " \
                          -bg honeydew2


frame $w.topr.frm33 -bg honeydew2

  scale $w.topr.frm33.scl1  -variable ormin \
                     -from -10 -to 1 -bg honeydew2 \
                     -orient horizontal\
		     -command {scalay "min"}

 scale $w.topr.frm33.scl2 -variable ormax \
                     -from -10 -to 1 -bg honeydew2 \
                     -orient horizontal\
		     -command {scalay "max"}


  frame $w.topr.frm34
 
  button $w.topr.frm34.btn3 -text {trace 2} \
        -command "savetrace 2" -bg yellow -relief groove

  button $w.topr.frm34.btn31 -text {del trace 2} \
        -command "deltrace 2" -bg yellow -relief groove




 frame $w.topr.frm4 -bg aquamarine3

 label $w.topr.frm4.lbl41 -bg aquamarine3 -text "Averages"
 
 label $w.topr.frm4.lbl4 -bg aquamarine3 -textvariable medcount
 radiobutton $w.topr.frm4.rdb1 \
                           -text "On" \
                           -variable flagmed \
                           -value 1  \
                           -bg aquamarine3\
                           -command {if {$flag1 ==1} {set flag1 2} }

 radiobutton $w.topr.frm4.rdb2 \
                           -text "Off" \
                           -variable flagmed \
                           -value 0  \
                           -bg aquamarine3  \
                           -command {if {$flag1 ==1} {set flag1 2}}


 frame $w.topr.frm5 -bg lightblue

button $w.topr.frm5.btn1 -text {Print} \
        -command "$w.top.graph postscript output xy.ps -maxpect yes -decorations no; exec lpr xy.ps " \
        -bg lightblue \
        -width 4 -relief groove

button $w.topr.frm5.btn2 -text {Save in file :} \
        -command "save" \
        -bg lightblue \
        -width 9 -relief groove

entry $w.topr.frm5.fle  -relief sunken -textvariable nomesave \
                         -bg lightblue  -width 10


 frame $w.topr.frm7

 radiobutton $w.topr.frm7.rdb1 \
                           -text "Run" \
                           -variable flag1 \
                           -value 1  \
                           -bg lightblue \
                           -command {holddata; scalax $flagr 0; acquire}

 radiobutton $w.topr.frm7.rdb2 \
                           -text "Stop" \
                           -variable flag1 \
                           -value 0  \
                           -bg lightblue \
                           -command {release}



button $w.topr.btn8 -text {EXIT} \
     -command "exit" -bg lightblue



pack $w.top $w.topr -side left -expand yes -fill both
pack $w.top.frm1 $w.top.graph -fill both
pack $w.top.frm1.lbl1 $w.top.frm1.lbl2 -side left


pack $w.topr.lbl1 $w.topr.lbl11 $w.topr.frm11 -fill both -expand yes
pack $w.topr.frm11.freq $w.topr.frm11.points  $w.topr.frm11.lblpnt $w.topr.frm11.quantum -fill both -expand yes -side left

pack $w.topr.lbl12 $w.topr.frm12 -fill both -expand yes
pack $w.topr.frm12.rdb1 $w.topr.frm12.rdb2 $w.topr.frm12.rdb3 $w.topr.frm12.rdb4 -side left -fill both -expand yes

pack $w.topr.lbl2 $w.topr.lbl21 $w.topr.frm21 -fill both -expand yes
pack $w.topr.frm21.rdb1 $w.topr.frm21.rdb2 $w.topr.frm21.filfr -side left -fill both -expand yes
pack $w.topr.lbl22 $w.topr.frm22 -fill both -expand yes
pack $w.topr.frm22.scl1 $w.topr.frm22.scl2 -side left -fill both -expand yes

  

pack $w.topr.frm31 -fill both -expand yes
pack $w.topr.frm31.btn32 $w.topr.frm31.btn3  $w.topr.frm31.btn31 -fill both -expand yes -side left

pack $w.topr.frm320 $w.topr.frm320.lbl1 -fill both -expand yes


pack $w.topr.frm32 -fill both -expand yes
pack $w.topr.frm32.scl1 $w.topr.frm32.scl2 -side left -fill both -expand yes

pack $w.topr.frm330 $w.topr.frm330.lbl1 -fill both -expand yes

pack $w.topr.frm33 -fill both -expand yes
pack $w.topr.frm33.scl1 $w.topr.frm33.scl2 -side left -fill both -expand yes


pack $w.topr.frm34 -fill both -expand yes
pack $w.topr.frm34.btn3 $w.topr.frm34.btn31  -fill both -expand yes -side left

pack $w.topr.frm4 -expand yes -fill both
pack  $w.topr.frm4.lbl41 $w.topr.frm4.lbl4 $w.topr.frm4.rdb1 $w.topr.frm4.rdb2 -side left -fill both -expand yes

pack $w.topr.frm5 -expand yes -fill both
pack $w.topr.frm5.btn1 $w.topr.frm5.btn2 $w.topr.frm5.fle -side left -fill both -expand yes

pack $w.topr.frm7 -expand yes -fill both
pack $w.topr.frm7.rdb1 $w.topr.frm7.rdb2 -side left -fill both -expand yes
pack $w.topr.btn8 -fill both -expand yes 

}

###############    ACQUIRE Procedure    ####################

proc acquire {} {



  set tcl_precision 12

  global fr b2npt npti flag1 medcount quantum flagmed medval
  global scl cutfreq acdc infilgain outfilgain
  global device1  f1 X Y asmin asmax cmdm gpibflag


  holddata

  #_____ Parameters Setting _______#

  set fr [expr int($fr)]
  set cutfreq [expr 80*$fr/200.0]
  set outfilgn [expr $outfilgain/10]
  set infilgn [expr $infilgain/10]
  set dt [expr (1.0 / $fr) ]
  set totgain [expr $quantum*pow(10,$infilgain/20.0)*pow(10,$outfilgain/20.0) ]
  set punti [expr 13*$npti/2 -1]
  set npfr [expr 1.0*$npti/$fr] 


  #_______  PCI-DAS1602 card Initialization _______#

  set f1 [open |./adcconvert r+]

  puts $f1 $npti
  puts $f1 $fr
  puts $f1 $scl
  puts $f1 $flagmed
  puts $f1 $totgain
  flush $f1  
  gets $f1 fr


  #_____ Low pass filter initialization ______#


  if { $gpibflag == 1} {
    gpib write $device1 "PREG 2,$infilgn"
    gpib write $device1 "FREQ 2,$cutfreq" 
    gpib write $device1 "PSTG 2,$outfilgn"
    gpib write $device1 "ACDC 2,$acdc"
  }  

  #_________ Acquisition _______________#


      set indice 0

      vector create X([expr $npti/2-1])
      vector create Y
      vector create Ym

      while {$indice < [expr $npti/2-1] } {

      set X($indice)  [expr (1.0*$fr/$npti)*$indice]
        incr indice
      }

      set cmd {}
      if {$flagmed == 1} {set cmd {incr medcount}}


  set medcount 0
 
      Y set [read $f1 $punti]
      set Z [read $f1 1]

      if {[.frm0.top.graph element exists line1] == 0} {
     .frm0.top.graph element create line1 -xdata X -ydata Y
     .frm0.top.graph element configure line1 -symbol none  -color brown -label ""
      }


  while { $flag1 ==1 } {

      Y set [read $f1 $punti]
      set Z [read $f1 1]
 
      eval $cmd
      eval $cmdm
   }

   catch {close $f1} errore
   if {$flag1==2} {
   set flag1 1
   acquire 
   }

}



 # Freezing procedure

proc holddata {} {


    .frm0.topr.frm11.freq config -state disabled
    .frm0.topr.frm11.points config -state disabled
    .frm0.topr.frm11.quantum config -state disabled
    .frm0.topr.frm12.rdb1 config -state disabled
    .frm0.topr.frm12.rdb2 config -state disabled
    .frm0.topr.frm12.rdb3 config -state disabled
    .frm0.topr.frm12.rdb4 config -state disabled
    .frm0.topr.frm21.rdb1 config -state disabled
    .frm0.topr.frm21.rdb2 config -state disabled
    .frm0.topr.frm21.filfr config -state disabled
    .frm0.topr.frm22.scl2 config -state disabled
    .frm0.topr.frm22.scl1 config -state disabled
#    .frm0.topr.frm4.rdb1 config -state disabled
#    .frm0.topr.frm4.rdb2 config -state disabled
    .frm0.topr.frm5.btn2 config -state disabled
    .frm0.topr.frm7.rdb1 config -state disabled
}

# Release  procedure

proc release {} {

     global gpibflag
    
    .frm0.topr.frm11.freq config -state normal
    .frm0.topr.frm11.points config -state normal
    .frm0.topr.frm11.quantum config -state normal
    .frm0.topr.frm12.rdb1 config -state normal
    .frm0.topr.frm12.rdb2 config -state normal
    .frm0.topr.frm12.rdb3 config -state normal
    .frm0.topr.frm12.rdb4 config -state normal
    .frm0.topr.frm5.btn2 config -state normal
    .frm0.topr.frm7.rdb1 config -state normal

    if {$gpibflag == 1 } {
      .frm0.topr.frm21.rdb1 config -state normal
      .frm0.topr.frm21.rdb2 config -state normal
      .frm0.topr.frm21.filfr config -state normal
      .frm0.topr.frm22.scl2 config -state normal
      .frm0.topr.frm22.scl1 config -state normal
    }
}



# Save procedure


proc save {} {

    
    global nomesave npti X Y

      set filesave [open $nomesave w]
      set indice 0
      while {$indice < [expr $npti/2-1] } {
        puts $filesave  "$X($indice)     $Y($indice)"
        incr indice
      }
      close  $filesave

}
# Save trace procedure

proc savetrace {tr} {

    
    global npti fr X Y

      set XX 0
      set YY 0
      unset XX
      unset YY 
      set indice 0 
      while {$indice < [expr $npti/2-1] } {
        lappend XX $X($indice)
        lappend  YY $Y($indice)
        incr indice
      }
  
      if {[.frm0.top.graph element exists line$tr] == 0} {

      .frm0.top.graph element create line$tr -xdata $XX -ydata $YY -color red \
      -label ""

     .frm0.top.graph element configure line$tr -symbol none
      } else {
     .frm0.top.graph element configure line$tr -xdata $XX -ydata $YY
      }

}

# Delete trace procedure

proc deltrace {tr} {

     if {[.frm0.top.graph element exists line$tr] == 1} {

      .frm0.top.graph element delete line$tr
     }
 }


# Scala procedure

proc scalax {axis as} {

  global asmax asmin fr npti medval cmds cmdm cmd1 cmd2 flagr

 
   if { $axis == "minlg" } {
      set flagr "minlg" 
      set medval ""  
      set cmdm $cmd2
      set axis "min"
     .frm0.top.graph axis configure x -$axis 1
     .frm0.top.graph axis configure y -logscale true
     .frm0.top.graph axis configure x -logscale true
     .frm0.topr.frm32.scl1 config -from -3
     .frm0.topr.frm32.scl1 config -to 5
     .frm0.topr.frm32.scl2 config -from -2
     .frm0.topr.frm32.scl2 config -to 5
     .frm0.top.graph axis configure x -$axis [expr pow(10,$as)]
     .frm0.top.graph axis configure x -max [expr $fr/2]
     set asmax [expr ceil(log10(1.0*$fr/2))]
     set asmin 0
     set cmds { .frm0.top.graph axis configure x -$axis [expr pow(10,$as)] }
     return
 }

   if {$axis == "minl" } {
     set flagr "minl" 
     set cmdm $cmd1
     set axis "min"
     .frm0.top.graph axis configure x -logscale false
     .frm0.top.graph axis configure y -logscale true
     .frm0.topr.frm32.scl1 config -from 0
     .frm0.topr.frm32.scl1 config -to [expr $fr/2]
     .frm0.topr.frm32.scl2 config -from -0
     .frm0.topr.frm32.scl2 config -to [expr $fr/2]
     .frm0.top.graph axis configure x -$axis $as
     .frm0.top.graph axis configure x -max [expr $fr/2]
     set asmin 0
     set asmax [expr $fr/2]
     set cmds { .frm0.top.graph axis configure x -$axis $as }
     return
    }

   if {$axis == "minli" } {
      set flagr "minli" 
      set cmdm $cmd1
      set axis "min"
     .frm0.top.graph axis configure x -logscale false
     .frm0.top.graph axis configure y -logscale false
     .frm0.topr.frm32.scl1 config -from 0
     .frm0.topr.frm32.scl1 config -to [expr $fr/2]
     .frm0.topr.frm32.scl2 config -from -0
     .frm0.topr.frm32.scl2 config -to [expr $fr/2]
     .frm0.top.graph axis configure x -$axis $as
     .frm0.top.graph axis configure x -max [expr $fr/2]
     set asmin 0
     set asmax [expr $fr/2]
     set cmds { .frm0.top.graph axis configure x -$axis $as }
     return
    }

  if {$asmax > $asmin} {eval $cmds}

 }



# Scala procedure

proc scalay {axis as} {

global ormax ormin

if {$ormax > $ormin} { .frm0.top.graph axis configure y -$axis [expr pow(10,$as)] }

 }

# Convert procedure

 proc convert {b2npt} {

  global npti

   set npti [expr int(pow(2,$b2npt))]
 
 }

#------------------------------------------------------------------#

###################  MAIN PROCEDURE ################################ 



  set auto_path "./"
  namespace import blt::*


  global flag1 flagr fr npti quantum nomesave scl acdc cutfreq b2npt
  global  infilgain outfilgain device1  f1 cmds cmdm cmd1 cmd2


  if { [file exists setup.ini] == 1} {

    set file [open "setup.ini" r]

      gets $file gpibflag   
      gets $file fr
      gets $file b2npt
      gets $file quantum
      gets $file nomesave 
      gets $file scl
      gets $file acdc
      gets $file infilgain
      gets $file outfilgain

     close $file
   } else {
     
     set gpibflag 1    ;# "1" if you have a low pass filter; "0" if not
     set fr 5000       ;# sample frequency
     set b2npt 10      ;# number of point for the fft routine (in power of 2)
     set quantum 1.0   ;# normalization factor of the frequency domain data
     set nomesave "spectrum.dat" ;# name of the file to save the spectrum
     set scl 1         ;# gain of the data acquisition board : possible values 
                      ;#  "8" ,"4" ,"2" ,"1" correspondig to real gain
                      ;#  1.25 , 2.5 , 5 ,10
     set acdc 0       ;# "0" ac coupled low pass filter; "1" dc coupled
     set infilgain 20  ;# low pass filter (dB) input gain 
     set outfilgain 0  ;# low pass filter (dB) output gain 

   }


  if { $gpibflag == 1} {
     load [info library]/libgpib.so
     set device1 [gpib find dualfilter ]
     gpib sic   $device1
     gpib clear $device1
     gpib write $device1 "*RST;"
  }

  set flagmed 0
  set flag1 0
  set flagr "minli"
  set cmds { .frm0.top.graph axis configure x -$axis $as }
  set cmd1 {Ym set [Y range [expr $npfr*$asmin] [expr $npfr*$asmax-1] ] ; set medval [vector expr median(Ym)]; update }

  set cmd2 { update }
  set cmdm $cmd1


  frame .frm0 
  pack  .frm0



  plot

  if { $gpibflag == 0} {
      .frm0.topr.frm21.rdb1  config -state disabled
      .frm0.topr.frm21.rdb2  config -state disabled
      .frm0.topr.frm21.filfr  config -state disabled
      .frm0.topr.frm22.scl1  config -state disabled
      .frm0.topr.frm22.scl2  config -state disabled
  }

#-------------------------------------------------------------------------#